; Tir-nan-og (2DD) (C)SYSTEMSOFT p
; C[` (for NASM)

%include 'hoot.inc'

		ORG	0x0100
		USE16
		CPU	186

start:		cli
		cld
		mov	sp,stack
		mov	bx,prgend
		shr	bx,4
		mov	ah,0x4a			; [DOS] ubN̏k(ES:BX)
		int	0x21
		jnc	.skip1
		hlt
.skip1:		mov	bx,0x8000		; 傫K
		mov	ah,0x48			; [DOS] 蓖
		int	0x21
		jnc	.skip2
		hlt
.skip2:		mov	[paramblk],ax		; 蓖ăAhXۑ
		mov	[paramblk+2],ax
		mov	bx,ax
		add	ax,0x1d10		; TEhhCoZOg̃ItZbg
		mov	[initentry+2],ax
		mov	[vsetentry+2],ax
		mov	[getofsentry+2],ax
		mov	[getsegentry+2],ax
		mov	[intsetentry1+2],ax
		mov	[intsetentry2+2],ax
		mov	[intsetentry3+2],ax
		mov	[intsetentry4+2],ax
		mov	[playentry+2],ax
		mov	[stopentry+2],ax
		mov	[fmoutentry+2],ax
		mov	ax,0x4b03		; [DOS] Overlay Load
		mov	dx,exec_path		; pX (DS:DX)
		mov	bx,paramblk		; p[^ubN(ES:BX)
		int	0x21
		jnc	.skip3
		hlt

.skip3:		call	far [getofsentry]	; [hAhX擾
		mov	[dataofs],ax
		call	far [getsegentry]
		mov	[dataseg],ax
		mov	ax,cs
		mov	ds,ax
		mov	ax,0x257f		; hoothCoo^
		mov	dx,vect_7f
		int	0x21
		call	far [cs:initentry]	; BIOS

		sti
mainloop:	mov	ax,0x9801		; _~[|[O
		int	0x18
		jmp	short mainloop

; hootR[
; inp8(HOOTPORT) = 0  PC98DOS::Play
; inp8(HOOTPORT) = 2  PC98DOS::Stop
; _code = inp8(HOOTPORT+2)`inp8(HOOTPORT+5)

vect_7f:	pusha
		push	ds
		push	es
		mov	ax,cs
		mov	ds,ax
		mov	dx,HOOTPORT
		in	al,dx
		cmp	al,HP_PLAY
		jz	short .play
		cmp	al,HP_STOP
		jz	short .stop
.ed:		pop	es
		pop	ds
		popa
		iret

.play:		cli
		call	far [cs:stopentry]	; t~
		call	mute			; 
		mov	cx,60			; 1b҂
.wait		call	vsync_wait
		loop	.wait
		call	far [cs:initentry]	; BIOS

		lds	dx,[cs:dataofs]		; ȃf[^AhX擾
		xor	bx,bx			; W
		mov	cx,0x1000		; TCY
		mov	ah,0x3f			; ȃf[^{̂̃[h (DS:DX)
		int	0x21
		jc	.ed

		mov	dx,HOOTPORT+2		; Ȕԍǂݍ
		in	al,dx
		and	al,0x0f
		cmp	al,4			; w肪傫܂
		jnc	.ed
		xor	ah,ah
		add	ax,ax
		xchg	bx,ax
		call	[cs:mussettable+bx]	; ȃf[^Zbg[`Ăяo
		call	far [cs:playentry]	; tJn
		jmp	short .ed

.stop:		call	far [cs:stopentry]	; t~
		call	mute			; 
		jmp	short .ed

; ȃf[^Zbg[`e[u
mussettable:	dw	musset0, musset1, musset2, musset3

; for TIR1022B
musset0:	push	word 0x0009
		push	word 0x0000
		call	far [cs:vsetentry]	; Fݒ(FM.1 @9)
		add	sp,4
		push	word 0x0000
		push	word 0x0001
		call	far [cs:vsetentry]	; Fݒ(FM.2 @0)
		add	sp,4
		call	mute			; 
		push	word 0x032f		; obt@c
		push	word 0x0000		; `lԍ
		call	far [cs:intsetentry1]	; ݏݒ
		add	sp,4
		ret

; for TIR1023B
musset1:	push	word 0x0001
		push	word 0x0000
		call	far [cs:vsetentry]	; Fݒ(FM.1 @1)
		add	sp,4
		push	word 0x0003
		push	word 0x0001
		call	far [cs:vsetentry]	; Fݒ(FM.2 @3)
		add	sp,4
		push	word 0x0002
		push	word 0x0002
		call	far [cs:vsetentry]	; Fݒ(FM.3 @2)
		add	sp,4
		call	mute			; 
		push	word 0x0149		; obt@c
		push	word 0x0000		; `lԍ
		call	far [cs:intsetentry2]	; ݏݒ
		add	sp,4
		ret

; for TIR1028B
musset2:	push	word 0x0001
		push	word 0x0000
		call	far [cs:vsetentry]	; Fݒ(FM.1 @1)
		add	sp,4
		push	word 0x0003
		push	word 0x0001
		call	far [cs:vsetentry]	; Fݒ(FM.2 @3)
		add	sp,4
		push	word 0x0004
		push	word 0x0002
		call	far [cs:vsetentry]	; Fݒ(FM.3 @4)
		add	sp,4
		call	mute			; 
		push	word 0x01d1		; obt@c
		push	word 0x0000		; `lԍ
		call	far [cs:intsetentry3]	; ݏݒ
		add	sp,4
		ret

; for TIR1029B
musset3:	push	word 0x0001
		push	word 0x0000
		call	far [cs:vsetentry]	; Fݒ(FM.1 @1)
		add	sp,4
		push	word 0x0003
		push	word 0x0001
		call	far [cs:vsetentry]	; Fݒ(FM.2 @3)
		add	sp,4
		push	word 0x0004
		push	word 0x0002
		call	far [cs:vsetentry]	; Fݒ(FM.3 @2)
		add	sp,4
		call	mute			; 
		push	word 0x027f		; obt@c
		push	word 0x0000		; `lԍ
		call	far [cs:intsetentry4]	; ݏݒ
		add	sp,4
		ret

; FM/SSG
mute:		push	word 0x0000
		push	word 0x0028
		call	far [cs:fmoutentry]
		add	sp,4
		push	word 0x0001
		push	word 0x0028
		call	far [cs:fmoutentry]
		add	sp,4
		push	word 0x0002
		push	word 0x0028
		call	far [cs:fmoutentry]
		add	sp,4
		push	word 0x0000
		push	word 0x0008
		call	far [cs:fmoutentry]
		add	sp,4
		push	word 0x0000
		push	word 0x0009
		call	far [cs:fmoutentry]
		add	sp,4
		push	word 0x0000
		push	word 0x000a
		call	far [cs:fmoutentry]
		add	sp,4
		ret

; VSYNC҂
vsync_wait:	mov	dx,0x00a0
.wait1:		in	al,dx
		and	al,0x20
		jnz	.wait1
.wait2:		in	al,dx
		and	al,0x20
		jz	.wait2
		ret

; ȃf[^[hAhX
dataofs:	dw	0
dataseg:	dw	0
; I[oC[hppX
exec_path:	db	'TIR1.EXE',00

; far callpGg
initentry:	dw	0x0001		; BIOS
		dw	0

vsetentry:	dw	0x044c		; Fݒ
		dw	0

getofsentry:	dw	0x0241		; ȃf[^obt@ItZbg擾
		dw	0

getsegentry:	dw	0x023d		; ȃf[^obt@ZOg擾
		dw	0

intsetentry1:	dw	0x0160		; ݏݒ1
		dw	0

intsetentry2:	dw	0x0185		; ݏݒ2
		dw	0

intsetentry3:	dw	0x01aa		; ݏݒ3
		dw	0

intsetentry4:	dw	0x01cf		; ݏݒ4
		dw	0

playentry:	dw	0x0035		; tJn
		dw	0

stopentry:	dw	0x011d		; t~
		dw	0

fmoutentry:	dw	0x006a		; FMo
		dw	0

; I[oC[hpp[^ubN
paramblk:	dw	0		; [hZOg
		dw	0		; P[Vt@N^

		times 0x200 db 0x00	; X^bNGA
stack:

		align	0x10
prgend:		

		ends

